/****************************************************************************\
*   PMALLOC - this header file is part of Binary vIEW project (BIEW)         *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/pmalloc.h                                      *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain prototypes of preemptive memory allocation technology.  *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/

#ifndef __PMALLOC_H
#define __PMALLOC_H 1

#include <stddef.h>

#ifndef __BIEWLIB_H
#include "lib/biewlib.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern void *           __FASTCALL__ PMalloc(size_t obj_size);
extern void *           __FASTCALL__ PRealloc(void *ptr,size_t obj_size);
extern void             __FASTCALL__ PFree(void *ptr);
extern void __HUGE__ *  __FASTCALL__ PHMalloc(unsigned long obj_size);
extern void __HUGE__ *  __FASTCALL__ PHRealloc(void __HUGE__ *ptr,unsigned long obj_size);
extern void             __FASTCALL__ PHFree(void __HUGE__ * ptr);

/* Free pointer and nullify it */
#define PFREE(ptr)      { PFree(ptr); ptr = 0; }
#define PHFREE(ptr)     { PHFree(ptr); ptr = 0; }

/* Registry/unregistry low memory callback handler */

/* Low memory callback handler receive on input size of
   needed memory for allocation.
   Must return:
   False - if it freed 0 bytes of memory
   True  - if it freed X bytes memory */

typedef tBool   (__FASTCALL__ *LowMemCallBack)(unsigned long need_mem);

extern tBool    __FASTCALL__ PMRegLowMemCallBack(LowMemCallBack func);
extern tBool    __FASTCALL__ PMUnregLowMemCallBack(LowMemCallBack func);

#ifdef __cplusplus
}
#endif

#endif

